; Portals - 2003-12-16 - Version 0.5

;### Constants, Variables and Types ################################################################

Type room			; A room (cell)
	Field id		; Room ID
	Field mesh		; Mesh handle
	Field x,y		; Position
	Field w,h		; Size
	Field vis[5]	; Other rooms visible from this one
	Field name$		; Room name
End Type

Global room_current		; The portal the player is in
Global room_name$		; The name of the portal the player is in

;### Functions #####################################################################################

Function RoomAdd(id,x,y,w,h,fil$)
	; Adds a room to the level. Size and position must be known.
	r.room=New room
	r\id=id : r\x=x : r\y=y : r\w=w : r\h=h		; Set position and size
	r\mesh=LoadMesh(fil$)						; Load the mesh
		EntityType r\mesh,COLL_LEVEL			; Set collision type. Constant defined elsewhere
		EntityPickMode r\mesh,2,True			; Set polygon pick mode
	PositionEntity r\mesh,x,0,y					; Position the mesh
End Function

;-------------------------------------------------

Function RoomUpdate(x,y)
	; Checks which room the player is in and shows/hides rooms accordingly
	ch=0	; Set if we need to change room
	For r.room=Each room
		rx=r\x : ry=r\y : rw=r\w : rh=r\h
		If x>rx And x<rx+rw And y>ry And y<ry+rh
			If room_current <> r\id
				ch=1 : room_current=r\id : room_name$=r\name$
				v1=r\vis[1] : v2=r\vis[2] : v3=r\vis[3] : v4=r\vis[4] : v5=r\vis[5]
			EndIf
		EndIf
	Next
	; If we have changed room, hide/show other rooms
	If ch=1
		For r.room=Each room
			id=r\id
			If id=v1 Or id=v2 Or id=v3 Or id=v4 Or id=v5 Or id=room_current
				ShowEntity r\mesh
			Else
				HideEntity r\mesh
			EndIf
		Next
	EndIf
End Function

;-------------------------------------------------

Function RoomDelete()
	; Deletes all rooms loaded
	For r.room=Each room
		FreeEntity r\mesh	; Free mesh from memory
		Delete r			; Delete the type instance
	Next
End Function

;-------------------------------------------------

Function RoomSetVis(id,v1,v2,v3,v4,v5)
	; Sets which other rooms are visible from this one
	For r.room=Each room
		If r\id=id
			r\vis[1]=v1 : r\vis[2]=v2 : r\vis[3]=v3 : r\vis[4]=v4 : r\vis[5]=v5
		EndIf
	Next
End Function

;-------------------------------------------------

Function RoomSetName(id,name$)
	; Sets the name for a room
	For r.room=Each room
		If r\id=id Then r\name$=name$
	Next
End Function

;-------------------------------------------------
